// ------------------------------------------------------------------
// Copyright (c) 2004-2010 Atheros Corporation.  All rights reserved.
// 
//
// Permission to use, copy, modify, and/or distribute this software for any
// purpose with or without fee is hereby granted, provided that the above
// copyright notice and this permission notice appear in all copies.
//
// THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
// WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
// ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
// ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
// OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
//
//
// ------------------------------------------------------------------
//===================================================================
// Author(s): ="Atheros"
//===================================================================


#ifndef _GPIO_ATHR_WLAN_REG_REG_H_
#define _GPIO_ATHR_WLAN_REG_REG_H_

#define WLAN_GPIO_OUT_ADDRESS                    0x00000000
#define WLAN_GPIO_OUT_OFFSET                     0x00000000
#define WLAN_GPIO_OUT_DATA_MSB                   25
#define WLAN_GPIO_OUT_DATA_LSB                   0
#define WLAN_GPIO_OUT_DATA_MASK                  0x03ffffff
#define WLAN_GPIO_OUT_DATA_GET(x)                (((x) & WLAN_GPIO_OUT_DATA_MASK) >> WLAN_GPIO_OUT_DATA_LSB)
#define WLAN_GPIO_OUT_DATA_SET(x)                (((x) << WLAN_GPIO_OUT_DATA_LSB) & WLAN_GPIO_OUT_DATA_MASK)

#define WLAN_GPIO_OUT_W1TS_ADDRESS               0x00000004
#define WLAN_GPIO_OUT_W1TS_OFFSET                0x00000004
#define WLAN_GPIO_OUT_W1TS_DATA_MSB              25
#define WLAN_GPIO_OUT_W1TS_DATA_LSB              0
#define WLAN_GPIO_OUT_W1TS_DATA_MASK             0x03ffffff
#define WLAN_GPIO_OUT_W1TS_DATA_GET(x)           (((x) & WLAN_GPIO_OUT_W1TS_DATA_MASK) >> WLAN_GPIO_OUT_W1TS_DATA_LSB)
#define WLAN_GPIO_OUT_W1TS_DATA_SET(x)           (((x) << WLAN_GPIO_OUT_W1TS_DATA_LSB) & WLAN_GPIO_OUT_W1TS_DATA_MASK)

#define WLAN_GPIO_OUT_W1TC_ADDRESS               0x00000008
#define WLAN_GPIO_OUT_W1TC_OFFSET                0x00000008
#define WLAN_GPIO_OUT_W1TC_DATA_MSB              25
#define WLAN_GPIO_OUT_W1TC_DATA_LSB              0
#define WLAN_GPIO_OUT_W1TC_DATA_MASK             0x03ffffff
#define WLAN_GPIO_OUT_W1TC_DATA_GET(x)           (((x) & WLAN_GPIO_OUT_W1TC_DATA_MASK) >> WLAN_GPIO_OUT_W1TC_DATA_LSB)
#define WLAN_GPIO_OUT_W1TC_DATA_SET(x)           (((x) << WLAN_GPIO_OUT_W1TC_DATA_LSB) & WLAN_GPIO_OUT_W1TC_DATA_MASK)

#define WLAN_GPIO_ENABLE_ADDRESS                 0x0000000c
#define WLAN_GPIO_ENABLE_OFFSET                  0x0000000c
#define WLAN_GPIO_ENABLE_DATA_MSB                25
#define WLAN_GPIO_ENABLE_DATA_LSB                0
#define WLAN_GPIO_ENABLE_DATA_MASK               0x03ffffff
#define WLAN_GPIO_ENABLE_DATA_GET(x)             (((x) & WLAN_GPIO_ENABLE_DATA_MASK) >> WLAN_GPIO_ENABLE_DATA_LSB)
#define WLAN_GPIO_ENABLE_DATA_SET(x)             (((x) << WLAN_GPIO_ENABLE_DATA_LSB) & WLAN_GPIO_ENABLE_DATA_MASK)

#define WLAN_GPIO_ENABLE_W1TS_ADDRESS            0x00000010
#define WLAN_GPIO_ENABLE_W1TS_OFFSET             0x00000010
#define WLAN_GPIO_ENABLE_W1TS_DATA_MSB           25
#define WLAN_GPIO_ENABLE_W1TS_DATA_LSB           0
#define WLAN_GPIO_ENABLE_W1TS_DATA_MASK          0x03ffffff
#define WLAN_GPIO_ENABLE_W1TS_DATA_GET(x)        (((x) & WLAN_GPIO_ENABLE_W1TS_DATA_MASK) >> WLAN_GPIO_ENABLE_W1TS_DATA_LSB)
#define WLAN_GPIO_ENABLE_W1TS_DATA_SET(x)        (((x) << WLAN_GPIO_ENABLE_W1TS_DATA_LSB) & WLAN_GPIO_ENABLE_W1TS_DATA_MASK)

#define WLAN_GPIO_ENABLE_W1TC_ADDRESS            0x00000014
#define WLAN_GPIO_ENABLE_W1TC_OFFSET             0x00000014
#define WLAN_GPIO_ENABLE_W1TC_DATA_MSB           25
#define WLAN_GPIO_ENABLE_W1TC_DATA_LSB           0
#define WLAN_GPIO_ENABLE_W1TC_DATA_MASK          0x03ffffff
#define WLAN_GPIO_ENABLE_W1TC_DATA_GET(x)        (((x) & WLAN_GPIO_ENABLE_W1TC_DATA_MASK) >> WLAN_GPIO_ENABLE_W1TC_DATA_LSB)
#define WLAN_GPIO_ENABLE_W1TC_DATA_SET(x)        (((x) << WLAN_GPIO_ENABLE_W1TC_DATA_LSB) & WLAN_GPIO_ENABLE_W1TC_DATA_MASK)

#define WLAN_GPIO_IN_ADDRESS                     0x00000018
#define WLAN_GPIO_IN_OFFSET                      0x00000018
#define WLAN_GPIO_IN_DATA_MSB                    25
#define WLAN_GPIO_IN_DATA_LSB                    0
#define WLAN_GPIO_IN_DATA_MASK                   0x03ffffff
#define WLAN_GPIO_IN_DATA_GET(x)                 (((x) & WLAN_GPIO_IN_DATA_MASK) >> WLAN_GPIO_IN_DATA_LSB)
#define WLAN_GPIO_IN_DATA_SET(x)                 (((x) << WLAN_GPIO_IN_DATA_LSB) & WLAN_GPIO_IN_DATA_MASK)

#define WLAN_GPIO_STATUS_ADDRESS                 0x0000001c
#define WLAN_GPIO_STATUS_OFFSET                  0x0000001c
#define WLAN_GPIO_STATUS_INTERRUPT_MSB           25
#define WLAN_GPIO_STATUS_INTERRUPT_LSB           0
#define WLAN_GPIO_STATUS_INTERRUPT_MASK          0x03ffffff
#define WLAN_GPIO_STATUS_INTERRUPT_GET(x)        (((x) & WLAN_GPIO_STATUS_INTERRUPT_MASK) >> WLAN_GPIO_STATUS_INTERRUPT_LSB)
#define WLAN_GPIO_STATUS_INTERRUPT_SET(x)        (((x) << WLAN_GPIO_STATUS_INTERRUPT_LSB) & WLAN_GPIO_STATUS_INTERRUPT_MASK)

#define WLAN_GPIO_STATUS_W1TS_ADDRESS            0x00000020
#define WLAN_GPIO_STATUS_W1TS_OFFSET             0x00000020
#define WLAN_GPIO_STATUS_W1TS_INTERRUPT_MSB      25
#define WLAN_GPIO_STATUS_W1TS_INTERRUPT_LSB      0
#define WLAN_GPIO_STATUS_W1TS_INTERRUPT_MASK     0x03ffffff
#define WLAN_GPIO_STATUS_W1TS_INTERRUPT_GET(x)   (((x) & WLAN_GPIO_STATUS_W1TS_INTERRUPT_MASK) >> WLAN_GPIO_STATUS_W1TS_INTERRUPT_LSB)
#define WLAN_GPIO_STATUS_W1TS_INTERRUPT_SET(x)   (((x) << WLAN_GPIO_STATUS_W1TS_INTERRUPT_LSB) & WLAN_GPIO_STATUS_W1TS_INTERRUPT_MASK)

#define WLAN_GPIO_STATUS_W1TC_ADDRESS            0x00000024
#define WLAN_GPIO_STATUS_W1TC_OFFSET             0x00000024
#define WLAN_GPIO_STATUS_W1TC_INTERRUPT_MSB      25
#define WLAN_GPIO_STATUS_W1TC_INTERRUPT_LSB      0
#define WLAN_GPIO_STATUS_W1TC_INTERRUPT_MASK     0x03ffffff
#define WLAN_GPIO_STATUS_W1TC_INTERRUPT_GET(x)   (((x) & WLAN_GPIO_STATUS_W1TC_INTERRUPT_MASK) >> WLAN_GPIO_STATUS_W1TC_INTERRUPT_LSB)
#define WLAN_GPIO_STATUS_W1TC_INTERRUPT_SET(x)   (((x) << WLAN_GPIO_STATUS_W1TC_INTERRUPT_LSB) & WLAN_GPIO_STATUS_W1TC_INTERRUPT_MASK)

#define WLAN_GPIO_PIN0_ADDRESS                   0x00000028
#define WLAN_GPIO_PIN0_OFFSET                    0x00000028
#define WLAN_GPIO_PIN0_CONFIG_MSB                13
#define WLAN_GPIO_PIN0_CONFIG_LSB                11
#define WLAN_GPIO_PIN0_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN0_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN0_CONFIG_MASK) >> WLAN_GPIO_PIN0_CONFIG_LSB)
#define WLAN_GPIO_PIN0_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN0_CONFIG_LSB) & WLAN_GPIO_PIN0_CONFIG_MASK)
#define WLAN_GPIO_PIN0_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN0_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN0_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN0_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN0_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN0_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN0_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN0_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN0_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN0_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN0_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN0_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN0_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN0_INT_TYPE_MASK) >> WLAN_GPIO_PIN0_INT_TYPE_LSB)
#define WLAN_GPIO_PIN0_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN0_INT_TYPE_LSB) & WLAN_GPIO_PIN0_INT_TYPE_MASK)
#define WLAN_GPIO_PIN0_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN0_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN0_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN0_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN0_PAD_PULL_MASK) >> WLAN_GPIO_PIN0_PAD_PULL_LSB)
#define WLAN_GPIO_PIN0_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN0_PAD_PULL_LSB) & WLAN_GPIO_PIN0_PAD_PULL_MASK)
#define WLAN_GPIO_PIN0_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN0_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN0_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN0_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN0_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN0_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN0_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN0_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN0_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN0_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN0_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN0_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN0_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN0_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN0_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN0_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN0_PAD_DRIVER_LSB) & WLAN_GPIO_PIN0_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN0_SOURCE_MSB                0
#define WLAN_GPIO_PIN0_SOURCE_LSB                0
#define WLAN_GPIO_PIN0_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN0_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN0_SOURCE_MASK) >> WLAN_GPIO_PIN0_SOURCE_LSB)
#define WLAN_GPIO_PIN0_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN0_SOURCE_LSB) & WLAN_GPIO_PIN0_SOURCE_MASK)

#define WLAN_GPIO_PIN1_ADDRESS                   0x0000002c
#define WLAN_GPIO_PIN1_OFFSET                    0x0000002c
#define WLAN_GPIO_PIN1_CONFIG_MSB                13
#define WLAN_GPIO_PIN1_CONFIG_LSB                11
#define WLAN_GPIO_PIN1_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN1_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN1_CONFIG_MASK) >> WLAN_GPIO_PIN1_CONFIG_LSB)
#define WLAN_GPIO_PIN1_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN1_CONFIG_LSB) & WLAN_GPIO_PIN1_CONFIG_MASK)
#define WLAN_GPIO_PIN1_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN1_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN1_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN1_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN1_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN1_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN1_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN1_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN1_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN1_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN1_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN1_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN1_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN1_INT_TYPE_MASK) >> WLAN_GPIO_PIN1_INT_TYPE_LSB)
#define WLAN_GPIO_PIN1_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN1_INT_TYPE_LSB) & WLAN_GPIO_PIN1_INT_TYPE_MASK)
#define WLAN_GPIO_PIN1_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN1_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN1_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN1_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN1_PAD_PULL_MASK) >> WLAN_GPIO_PIN1_PAD_PULL_LSB)
#define WLAN_GPIO_PIN1_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN1_PAD_PULL_LSB) & WLAN_GPIO_PIN1_PAD_PULL_MASK)
#define WLAN_GPIO_PIN1_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN1_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN1_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN1_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN1_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN1_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN1_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN1_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN1_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN1_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN1_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN1_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN1_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN1_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN1_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN1_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN1_PAD_DRIVER_LSB) & WLAN_GPIO_PIN1_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN1_SOURCE_MSB                0
#define WLAN_GPIO_PIN1_SOURCE_LSB                0
#define WLAN_GPIO_PIN1_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN1_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN1_SOURCE_MASK) >> WLAN_GPIO_PIN1_SOURCE_LSB)
#define WLAN_GPIO_PIN1_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN1_SOURCE_LSB) & WLAN_GPIO_PIN1_SOURCE_MASK)

#define WLAN_GPIO_PIN2_ADDRESS                   0x00000030
#define WLAN_GPIO_PIN2_OFFSET                    0x00000030
#define WLAN_GPIO_PIN2_CONFIG_MSB                13
#define WLAN_GPIO_PIN2_CONFIG_LSB                11
#define WLAN_GPIO_PIN2_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN2_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN2_CONFIG_MASK) >> WLAN_GPIO_PIN2_CONFIG_LSB)
#define WLAN_GPIO_PIN2_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN2_CONFIG_LSB) & WLAN_GPIO_PIN2_CONFIG_MASK)
#define WLAN_GPIO_PIN2_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN2_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN2_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN2_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN2_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN2_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN2_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN2_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN2_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN2_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN2_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN2_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN2_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN2_INT_TYPE_MASK) >> WLAN_GPIO_PIN2_INT_TYPE_LSB)
#define WLAN_GPIO_PIN2_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN2_INT_TYPE_LSB) & WLAN_GPIO_PIN2_INT_TYPE_MASK)
#define WLAN_GPIO_PIN2_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN2_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN2_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN2_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN2_PAD_PULL_MASK) >> WLAN_GPIO_PIN2_PAD_PULL_LSB)
#define WLAN_GPIO_PIN2_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN2_PAD_PULL_LSB) & WLAN_GPIO_PIN2_PAD_PULL_MASK)
#define WLAN_GPIO_PIN2_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN2_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN2_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN2_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN2_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN2_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN2_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN2_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN2_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN2_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN2_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN2_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN2_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN2_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN2_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN2_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN2_PAD_DRIVER_LSB) & WLAN_GPIO_PIN2_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN2_SOURCE_MSB                0
#define WLAN_GPIO_PIN2_SOURCE_LSB                0
#define WLAN_GPIO_PIN2_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN2_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN2_SOURCE_MASK) >> WLAN_GPIO_PIN2_SOURCE_LSB)
#define WLAN_GPIO_PIN2_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN2_SOURCE_LSB) & WLAN_GPIO_PIN2_SOURCE_MASK)

#define WLAN_GPIO_PIN3_ADDRESS                   0x00000034
#define WLAN_GPIO_PIN3_OFFSET                    0x00000034
#define WLAN_GPIO_PIN3_CONFIG_MSB                13
#define WLAN_GPIO_PIN3_CONFIG_LSB                11
#define WLAN_GPIO_PIN3_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN3_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN3_CONFIG_MASK) >> WLAN_GPIO_PIN3_CONFIG_LSB)
#define WLAN_GPIO_PIN3_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN3_CONFIG_LSB) & WLAN_GPIO_PIN3_CONFIG_MASK)
#define WLAN_GPIO_PIN3_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN3_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN3_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN3_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN3_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN3_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN3_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN3_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN3_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN3_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN3_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN3_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN3_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN3_INT_TYPE_MASK) >> WLAN_GPIO_PIN3_INT_TYPE_LSB)
#define WLAN_GPIO_PIN3_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN3_INT_TYPE_LSB) & WLAN_GPIO_PIN3_INT_TYPE_MASK)
#define WLAN_GPIO_PIN3_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN3_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN3_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN3_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN3_PAD_PULL_MASK) >> WLAN_GPIO_PIN3_PAD_PULL_LSB)
#define WLAN_GPIO_PIN3_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN3_PAD_PULL_LSB) & WLAN_GPIO_PIN3_PAD_PULL_MASK)
#define WLAN_GPIO_PIN3_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN3_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN3_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN3_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN3_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN3_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN3_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN3_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN3_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN3_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN3_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN3_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN3_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN3_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN3_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN3_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN3_PAD_DRIVER_LSB) & WLAN_GPIO_PIN3_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN3_SOURCE_MSB                0
#define WLAN_GPIO_PIN3_SOURCE_LSB                0
#define WLAN_GPIO_PIN3_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN3_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN3_SOURCE_MASK) >> WLAN_GPIO_PIN3_SOURCE_LSB)
#define WLAN_GPIO_PIN3_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN3_SOURCE_LSB) & WLAN_GPIO_PIN3_SOURCE_MASK)

#define WLAN_GPIO_PIN4_ADDRESS                   0x00000038
#define WLAN_GPIO_PIN4_OFFSET                    0x00000038
#define WLAN_GPIO_PIN4_CONFIG_MSB                13
#define WLAN_GPIO_PIN4_CONFIG_LSB                11
#define WLAN_GPIO_PIN4_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN4_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN4_CONFIG_MASK) >> WLAN_GPIO_PIN4_CONFIG_LSB)
#define WLAN_GPIO_PIN4_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN4_CONFIG_LSB) & WLAN_GPIO_PIN4_CONFIG_MASK)
#define WLAN_GPIO_PIN4_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN4_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN4_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN4_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN4_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN4_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN4_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN4_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN4_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN4_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN4_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN4_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN4_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN4_INT_TYPE_MASK) >> WLAN_GPIO_PIN4_INT_TYPE_LSB)
#define WLAN_GPIO_PIN4_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN4_INT_TYPE_LSB) & WLAN_GPIO_PIN4_INT_TYPE_MASK)
#define WLAN_GPIO_PIN4_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN4_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN4_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN4_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN4_PAD_PULL_MASK) >> WLAN_GPIO_PIN4_PAD_PULL_LSB)
#define WLAN_GPIO_PIN4_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN4_PAD_PULL_LSB) & WLAN_GPIO_PIN4_PAD_PULL_MASK)
#define WLAN_GPIO_PIN4_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN4_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN4_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN4_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN4_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN4_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN4_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN4_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN4_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN4_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN4_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN4_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN4_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN4_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN4_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN4_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN4_PAD_DRIVER_LSB) & WLAN_GPIO_PIN4_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN4_SOURCE_MSB                0
#define WLAN_GPIO_PIN4_SOURCE_LSB                0
#define WLAN_GPIO_PIN4_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN4_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN4_SOURCE_MASK) >> WLAN_GPIO_PIN4_SOURCE_LSB)
#define WLAN_GPIO_PIN4_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN4_SOURCE_LSB) & WLAN_GPIO_PIN4_SOURCE_MASK)

#define WLAN_GPIO_PIN5_ADDRESS                   0x0000003c
#define WLAN_GPIO_PIN5_OFFSET                    0x0000003c
#define WLAN_GPIO_PIN5_CONFIG_MSB                13
#define WLAN_GPIO_PIN5_CONFIG_LSB                11
#define WLAN_GPIO_PIN5_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN5_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN5_CONFIG_MASK) >> WLAN_GPIO_PIN5_CONFIG_LSB)
#define WLAN_GPIO_PIN5_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN5_CONFIG_LSB) & WLAN_GPIO_PIN5_CONFIG_MASK)
#define WLAN_GPIO_PIN5_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN5_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN5_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN5_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN5_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN5_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN5_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN5_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN5_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN5_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN5_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN5_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN5_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN5_INT_TYPE_MASK) >> WLAN_GPIO_PIN5_INT_TYPE_LSB)
#define WLAN_GPIO_PIN5_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN5_INT_TYPE_LSB) & WLAN_GPIO_PIN5_INT_TYPE_MASK)
#define WLAN_GPIO_PIN5_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN5_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN5_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN5_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN5_PAD_PULL_MASK) >> WLAN_GPIO_PIN5_PAD_PULL_LSB)
#define WLAN_GPIO_PIN5_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN5_PAD_PULL_LSB) & WLAN_GPIO_PIN5_PAD_PULL_MASK)
#define WLAN_GPIO_PIN5_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN5_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN5_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN5_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN5_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN5_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN5_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN5_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN5_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN5_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN5_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN5_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN5_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN5_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN5_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN5_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN5_PAD_DRIVER_LSB) & WLAN_GPIO_PIN5_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN5_SOURCE_MSB                0
#define WLAN_GPIO_PIN5_SOURCE_LSB                0
#define WLAN_GPIO_PIN5_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN5_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN5_SOURCE_MASK) >> WLAN_GPIO_PIN5_SOURCE_LSB)
#define WLAN_GPIO_PIN5_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN5_SOURCE_LSB) & WLAN_GPIO_PIN5_SOURCE_MASK)

#define WLAN_GPIO_PIN6_ADDRESS                   0x00000040
#define WLAN_GPIO_PIN6_OFFSET                    0x00000040
#define WLAN_GPIO_PIN6_CONFIG_MSB                13
#define WLAN_GPIO_PIN6_CONFIG_LSB                11
#define WLAN_GPIO_PIN6_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN6_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN6_CONFIG_MASK) >> WLAN_GPIO_PIN6_CONFIG_LSB)
#define WLAN_GPIO_PIN6_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN6_CONFIG_LSB) & WLAN_GPIO_PIN6_CONFIG_MASK)
#define WLAN_GPIO_PIN6_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN6_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN6_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN6_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN6_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN6_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN6_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN6_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN6_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN6_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN6_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN6_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN6_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN6_INT_TYPE_MASK) >> WLAN_GPIO_PIN6_INT_TYPE_LSB)
#define WLAN_GPIO_PIN6_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN6_INT_TYPE_LSB) & WLAN_GPIO_PIN6_INT_TYPE_MASK)
#define WLAN_GPIO_PIN6_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN6_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN6_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN6_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN6_PAD_PULL_MASK) >> WLAN_GPIO_PIN6_PAD_PULL_LSB)
#define WLAN_GPIO_PIN6_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN6_PAD_PULL_LSB) & WLAN_GPIO_PIN6_PAD_PULL_MASK)
#define WLAN_GPIO_PIN6_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN6_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN6_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN6_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN6_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN6_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN6_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN6_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN6_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN6_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN6_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN6_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN6_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN6_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN6_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN6_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN6_PAD_DRIVER_LSB) & WLAN_GPIO_PIN6_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN6_SOURCE_MSB                0
#define WLAN_GPIO_PIN6_SOURCE_LSB                0
#define WLAN_GPIO_PIN6_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN6_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN6_SOURCE_MASK) >> WLAN_GPIO_PIN6_SOURCE_LSB)
#define WLAN_GPIO_PIN6_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN6_SOURCE_LSB) & WLAN_GPIO_PIN6_SOURCE_MASK)

#define WLAN_GPIO_PIN7_ADDRESS                   0x00000044
#define WLAN_GPIO_PIN7_OFFSET                    0x00000044
#define WLAN_GPIO_PIN7_CONFIG_MSB                13
#define WLAN_GPIO_PIN7_CONFIG_LSB                11
#define WLAN_GPIO_PIN7_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN7_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN7_CONFIG_MASK) >> WLAN_GPIO_PIN7_CONFIG_LSB)
#define WLAN_GPIO_PIN7_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN7_CONFIG_LSB) & WLAN_GPIO_PIN7_CONFIG_MASK)
#define WLAN_GPIO_PIN7_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN7_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN7_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN7_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN7_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN7_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN7_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN7_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN7_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN7_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN7_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN7_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN7_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN7_INT_TYPE_MASK) >> WLAN_GPIO_PIN7_INT_TYPE_LSB)
#define WLAN_GPIO_PIN7_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN7_INT_TYPE_LSB) & WLAN_GPIO_PIN7_INT_TYPE_MASK)
#define WLAN_GPIO_PIN7_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN7_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN7_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN7_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN7_PAD_PULL_MASK) >> WLAN_GPIO_PIN7_PAD_PULL_LSB)
#define WLAN_GPIO_PIN7_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN7_PAD_PULL_LSB) & WLAN_GPIO_PIN7_PAD_PULL_MASK)
#define WLAN_GPIO_PIN7_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN7_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN7_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN7_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN7_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN7_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN7_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN7_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN7_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN7_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN7_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN7_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN7_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN7_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN7_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN7_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN7_PAD_DRIVER_LSB) & WLAN_GPIO_PIN7_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN7_SOURCE_MSB                0
#define WLAN_GPIO_PIN7_SOURCE_LSB                0
#define WLAN_GPIO_PIN7_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN7_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN7_SOURCE_MASK) >> WLAN_GPIO_PIN7_SOURCE_LSB)
#define WLAN_GPIO_PIN7_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN7_SOURCE_LSB) & WLAN_GPIO_PIN7_SOURCE_MASK)

#define WLAN_GPIO_PIN8_ADDRESS                   0x00000048
#define WLAN_GPIO_PIN8_OFFSET                    0x00000048
#define WLAN_GPIO_PIN8_CONFIG_MSB                13
#define WLAN_GPIO_PIN8_CONFIG_LSB                11
#define WLAN_GPIO_PIN8_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN8_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN8_CONFIG_MASK) >> WLAN_GPIO_PIN8_CONFIG_LSB)
#define WLAN_GPIO_PIN8_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN8_CONFIG_LSB) & WLAN_GPIO_PIN8_CONFIG_MASK)
#define WLAN_GPIO_PIN8_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN8_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN8_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN8_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN8_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN8_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN8_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN8_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN8_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN8_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN8_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN8_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN8_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN8_INT_TYPE_MASK) >> WLAN_GPIO_PIN8_INT_TYPE_LSB)
#define WLAN_GPIO_PIN8_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN8_INT_TYPE_LSB) & WLAN_GPIO_PIN8_INT_TYPE_MASK)
#define WLAN_GPIO_PIN8_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN8_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN8_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN8_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN8_PAD_PULL_MASK) >> WLAN_GPIO_PIN8_PAD_PULL_LSB)
#define WLAN_GPIO_PIN8_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN8_PAD_PULL_LSB) & WLAN_GPIO_PIN8_PAD_PULL_MASK)
#define WLAN_GPIO_PIN8_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN8_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN8_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN8_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN8_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN8_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN8_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN8_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN8_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN8_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN8_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN8_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN8_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN8_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN8_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN8_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN8_PAD_DRIVER_LSB) & WLAN_GPIO_PIN8_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN8_SOURCE_MSB                0
#define WLAN_GPIO_PIN8_SOURCE_LSB                0
#define WLAN_GPIO_PIN8_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN8_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN8_SOURCE_MASK) >> WLAN_GPIO_PIN8_SOURCE_LSB)
#define WLAN_GPIO_PIN8_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN8_SOURCE_LSB) & WLAN_GPIO_PIN8_SOURCE_MASK)

#define WLAN_GPIO_PIN9_ADDRESS                   0x0000004c
#define WLAN_GPIO_PIN9_OFFSET                    0x0000004c
#define WLAN_GPIO_PIN9_CONFIG_MSB                13
#define WLAN_GPIO_PIN9_CONFIG_LSB                11
#define WLAN_GPIO_PIN9_CONFIG_MASK               0x00003800
#define WLAN_GPIO_PIN9_CONFIG_GET(x)             (((x) & WLAN_GPIO_PIN9_CONFIG_MASK) >> WLAN_GPIO_PIN9_CONFIG_LSB)
#define WLAN_GPIO_PIN9_CONFIG_SET(x)             (((x) << WLAN_GPIO_PIN9_CONFIG_LSB) & WLAN_GPIO_PIN9_CONFIG_MASK)
#define WLAN_GPIO_PIN9_WAKEUP_ENABLE_MSB         10
#define WLAN_GPIO_PIN9_WAKEUP_ENABLE_LSB         10
#define WLAN_GPIO_PIN9_WAKEUP_ENABLE_MASK        0x00000400
#define WLAN_GPIO_PIN9_WAKEUP_ENABLE_GET(x)      (((x) & WLAN_GPIO_PIN9_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN9_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN9_WAKEUP_ENABLE_SET(x)      (((x) << WLAN_GPIO_PIN9_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN9_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN9_INT_TYPE_MSB              9
#define WLAN_GPIO_PIN9_INT_TYPE_LSB              7
#define WLAN_GPIO_PIN9_INT_TYPE_MASK             0x00000380
#define WLAN_GPIO_PIN9_INT_TYPE_GET(x)           (((x) & WLAN_GPIO_PIN9_INT_TYPE_MASK) >> WLAN_GPIO_PIN9_INT_TYPE_LSB)
#define WLAN_GPIO_PIN9_INT_TYPE_SET(x)           (((x) << WLAN_GPIO_PIN9_INT_TYPE_LSB) & WLAN_GPIO_PIN9_INT_TYPE_MASK)
#define WLAN_GPIO_PIN9_PAD_PULL_MSB              6
#define WLAN_GPIO_PIN9_PAD_PULL_LSB              5
#define WLAN_GPIO_PIN9_PAD_PULL_MASK             0x00000060
#define WLAN_GPIO_PIN9_PAD_PULL_GET(x)           (((x) & WLAN_GPIO_PIN9_PAD_PULL_MASK) >> WLAN_GPIO_PIN9_PAD_PULL_LSB)
#define WLAN_GPIO_PIN9_PAD_PULL_SET(x)           (((x) << WLAN_GPIO_PIN9_PAD_PULL_LSB) & WLAN_GPIO_PIN9_PAD_PULL_MASK)
#define WLAN_GPIO_PIN9_PAD_STRENGTH_MSB          4
#define WLAN_GPIO_PIN9_PAD_STRENGTH_LSB          3
#define WLAN_GPIO_PIN9_PAD_STRENGTH_MASK         0x00000018
#define WLAN_GPIO_PIN9_PAD_STRENGTH_GET(x)       (((x) & WLAN_GPIO_PIN9_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN9_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN9_PAD_STRENGTH_SET(x)       (((x) << WLAN_GPIO_PIN9_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN9_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN9_PAD_DRIVER_MSB            2
#define WLAN_GPIO_PIN9_PAD_DRIVER_LSB            2
#define WLAN_GPIO_PIN9_PAD_DRIVER_MASK           0x00000004
#define WLAN_GPIO_PIN9_PAD_DRIVER_GET(x)         (((x) & WLAN_GPIO_PIN9_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN9_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN9_PAD_DRIVER_SET(x)         (((x) << WLAN_GPIO_PIN9_PAD_DRIVER_LSB) & WLAN_GPIO_PIN9_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN9_SOURCE_MSB                0
#define WLAN_GPIO_PIN9_SOURCE_LSB                0
#define WLAN_GPIO_PIN9_SOURCE_MASK               0x00000001
#define WLAN_GPIO_PIN9_SOURCE_GET(x)             (((x) & WLAN_GPIO_PIN9_SOURCE_MASK) >> WLAN_GPIO_PIN9_SOURCE_LSB)
#define WLAN_GPIO_PIN9_SOURCE_SET(x)             (((x) << WLAN_GPIO_PIN9_SOURCE_LSB) & WLAN_GPIO_PIN9_SOURCE_MASK)

#define WLAN_GPIO_PIN10_ADDRESS                  0x00000050
#define WLAN_GPIO_PIN10_OFFSET                   0x00000050
#define WLAN_GPIO_PIN10_CONFIG_MSB               13
#define WLAN_GPIO_PIN10_CONFIG_LSB               11
#define WLAN_GPIO_PIN10_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN10_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN10_CONFIG_MASK) >> WLAN_GPIO_PIN10_CONFIG_LSB)
#define WLAN_GPIO_PIN10_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN10_CONFIG_LSB) & WLAN_GPIO_PIN10_CONFIG_MASK)
#define WLAN_GPIO_PIN10_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN10_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN10_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN10_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN10_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN10_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN10_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN10_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN10_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN10_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN10_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN10_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN10_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN10_INT_TYPE_MASK) >> WLAN_GPIO_PIN10_INT_TYPE_LSB)
#define WLAN_GPIO_PIN10_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN10_INT_TYPE_LSB) & WLAN_GPIO_PIN10_INT_TYPE_MASK)
#define WLAN_GPIO_PIN10_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN10_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN10_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN10_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN10_PAD_PULL_MASK) >> WLAN_GPIO_PIN10_PAD_PULL_LSB)
#define WLAN_GPIO_PIN10_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN10_PAD_PULL_LSB) & WLAN_GPIO_PIN10_PAD_PULL_MASK)
#define WLAN_GPIO_PIN10_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN10_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN10_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN10_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN10_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN10_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN10_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN10_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN10_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN10_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN10_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN10_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN10_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN10_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN10_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN10_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN10_PAD_DRIVER_LSB) & WLAN_GPIO_PIN10_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN10_SOURCE_MSB               0
#define WLAN_GPIO_PIN10_SOURCE_LSB               0
#define WLAN_GPIO_PIN10_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN10_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN10_SOURCE_MASK) >> WLAN_GPIO_PIN10_SOURCE_LSB)
#define WLAN_GPIO_PIN10_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN10_SOURCE_LSB) & WLAN_GPIO_PIN10_SOURCE_MASK)

#define WLAN_GPIO_PIN11_ADDRESS                  0x00000054
#define WLAN_GPIO_PIN11_OFFSET                   0x00000054
#define WLAN_GPIO_PIN11_CONFIG_MSB               13
#define WLAN_GPIO_PIN11_CONFIG_LSB               11
#define WLAN_GPIO_PIN11_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN11_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN11_CONFIG_MASK) >> WLAN_GPIO_PIN11_CONFIG_LSB)
#define WLAN_GPIO_PIN11_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN11_CONFIG_LSB) & WLAN_GPIO_PIN11_CONFIG_MASK)
#define WLAN_GPIO_PIN11_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN11_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN11_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN11_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN11_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN11_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN11_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN11_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN11_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN11_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN11_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN11_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN11_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN11_INT_TYPE_MASK) >> WLAN_GPIO_PIN11_INT_TYPE_LSB)
#define WLAN_GPIO_PIN11_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN11_INT_TYPE_LSB) & WLAN_GPIO_PIN11_INT_TYPE_MASK)
#define WLAN_GPIO_PIN11_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN11_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN11_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN11_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN11_PAD_PULL_MASK) >> WLAN_GPIO_PIN11_PAD_PULL_LSB)
#define WLAN_GPIO_PIN11_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN11_PAD_PULL_LSB) & WLAN_GPIO_PIN11_PAD_PULL_MASK)
#define WLAN_GPIO_PIN11_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN11_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN11_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN11_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN11_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN11_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN11_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN11_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN11_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN11_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN11_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN11_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN11_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN11_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN11_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN11_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN11_PAD_DRIVER_LSB) & WLAN_GPIO_PIN11_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN11_SOURCE_MSB               0
#define WLAN_GPIO_PIN11_SOURCE_LSB               0
#define WLAN_GPIO_PIN11_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN11_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN11_SOURCE_MASK) >> WLAN_GPIO_PIN11_SOURCE_LSB)
#define WLAN_GPIO_PIN11_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN11_SOURCE_LSB) & WLAN_GPIO_PIN11_SOURCE_MASK)

#define WLAN_GPIO_PIN12_ADDRESS                  0x00000058
#define WLAN_GPIO_PIN12_OFFSET                   0x00000058
#define WLAN_GPIO_PIN12_CONFIG_MSB               13
#define WLAN_GPIO_PIN12_CONFIG_LSB               11
#define WLAN_GPIO_PIN12_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN12_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN12_CONFIG_MASK) >> WLAN_GPIO_PIN12_CONFIG_LSB)
#define WLAN_GPIO_PIN12_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN12_CONFIG_LSB) & WLAN_GPIO_PIN12_CONFIG_MASK)
#define WLAN_GPIO_PIN12_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN12_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN12_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN12_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN12_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN12_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN12_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN12_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN12_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN12_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN12_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN12_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN12_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN12_INT_TYPE_MASK) >> WLAN_GPIO_PIN12_INT_TYPE_LSB)
#define WLAN_GPIO_PIN12_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN12_INT_TYPE_LSB) & WLAN_GPIO_PIN12_INT_TYPE_MASK)
#define WLAN_GPIO_PIN12_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN12_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN12_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN12_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN12_PAD_PULL_MASK) >> WLAN_GPIO_PIN12_PAD_PULL_LSB)
#define WLAN_GPIO_PIN12_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN12_PAD_PULL_LSB) & WLAN_GPIO_PIN12_PAD_PULL_MASK)
#define WLAN_GPIO_PIN12_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN12_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN12_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN12_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN12_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN12_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN12_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN12_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN12_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN12_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN12_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN12_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN12_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN12_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN12_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN12_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN12_PAD_DRIVER_LSB) & WLAN_GPIO_PIN12_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN12_SOURCE_MSB               0
#define WLAN_GPIO_PIN12_SOURCE_LSB               0
#define WLAN_GPIO_PIN12_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN12_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN12_SOURCE_MASK) >> WLAN_GPIO_PIN12_SOURCE_LSB)
#define WLAN_GPIO_PIN12_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN12_SOURCE_LSB) & WLAN_GPIO_PIN12_SOURCE_MASK)

#define WLAN_GPIO_PIN13_ADDRESS                  0x0000005c
#define WLAN_GPIO_PIN13_OFFSET                   0x0000005c
#define WLAN_GPIO_PIN13_CONFIG_MSB               13
#define WLAN_GPIO_PIN13_CONFIG_LSB               11
#define WLAN_GPIO_PIN13_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN13_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN13_CONFIG_MASK) >> WLAN_GPIO_PIN13_CONFIG_LSB)
#define WLAN_GPIO_PIN13_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN13_CONFIG_LSB) & WLAN_GPIO_PIN13_CONFIG_MASK)
#define WLAN_GPIO_PIN13_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN13_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN13_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN13_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN13_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN13_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN13_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN13_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN13_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN13_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN13_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN13_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN13_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN13_INT_TYPE_MASK) >> WLAN_GPIO_PIN13_INT_TYPE_LSB)
#define WLAN_GPIO_PIN13_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN13_INT_TYPE_LSB) & WLAN_GPIO_PIN13_INT_TYPE_MASK)
#define WLAN_GPIO_PIN13_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN13_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN13_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN13_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN13_PAD_PULL_MASK) >> WLAN_GPIO_PIN13_PAD_PULL_LSB)
#define WLAN_GPIO_PIN13_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN13_PAD_PULL_LSB) & WLAN_GPIO_PIN13_PAD_PULL_MASK)
#define WLAN_GPIO_PIN13_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN13_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN13_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN13_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN13_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN13_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN13_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN13_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN13_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN13_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN13_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN13_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN13_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN13_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN13_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN13_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN13_PAD_DRIVER_LSB) & WLAN_GPIO_PIN13_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN13_SOURCE_MSB               0
#define WLAN_GPIO_PIN13_SOURCE_LSB               0
#define WLAN_GPIO_PIN13_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN13_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN13_SOURCE_MASK) >> WLAN_GPIO_PIN13_SOURCE_LSB)
#define WLAN_GPIO_PIN13_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN13_SOURCE_LSB) & WLAN_GPIO_PIN13_SOURCE_MASK)

#define WLAN_GPIO_PIN14_ADDRESS                  0x00000060
#define WLAN_GPIO_PIN14_OFFSET                   0x00000060
#define WLAN_GPIO_PIN14_CONFIG_MSB               13
#define WLAN_GPIO_PIN14_CONFIG_LSB               11
#define WLAN_GPIO_PIN14_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN14_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN14_CONFIG_MASK) >> WLAN_GPIO_PIN14_CONFIG_LSB)
#define WLAN_GPIO_PIN14_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN14_CONFIG_LSB) & WLAN_GPIO_PIN14_CONFIG_MASK)
#define WLAN_GPIO_PIN14_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN14_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN14_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN14_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN14_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN14_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN14_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN14_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN14_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN14_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN14_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN14_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN14_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN14_INT_TYPE_MASK) >> WLAN_GPIO_PIN14_INT_TYPE_LSB)
#define WLAN_GPIO_PIN14_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN14_INT_TYPE_LSB) & WLAN_GPIO_PIN14_INT_TYPE_MASK)
#define WLAN_GPIO_PIN14_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN14_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN14_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN14_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN14_PAD_PULL_MASK) >> WLAN_GPIO_PIN14_PAD_PULL_LSB)
#define WLAN_GPIO_PIN14_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN14_PAD_PULL_LSB) & WLAN_GPIO_PIN14_PAD_PULL_MASK)
#define WLAN_GPIO_PIN14_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN14_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN14_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN14_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN14_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN14_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN14_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN14_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN14_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN14_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN14_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN14_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN14_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN14_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN14_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN14_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN14_PAD_DRIVER_LSB) & WLAN_GPIO_PIN14_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN14_SOURCE_MSB               0
#define WLAN_GPIO_PIN14_SOURCE_LSB               0
#define WLAN_GPIO_PIN14_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN14_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN14_SOURCE_MASK) >> WLAN_GPIO_PIN14_SOURCE_LSB)
#define WLAN_GPIO_PIN14_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN14_SOURCE_LSB) & WLAN_GPIO_PIN14_SOURCE_MASK)

#define WLAN_GPIO_PIN15_ADDRESS                  0x00000064
#define WLAN_GPIO_PIN15_OFFSET                   0x00000064
#define WLAN_GPIO_PIN15_CONFIG_MSB               13
#define WLAN_GPIO_PIN15_CONFIG_LSB               11
#define WLAN_GPIO_PIN15_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN15_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN15_CONFIG_MASK) >> WLAN_GPIO_PIN15_CONFIG_LSB)
#define WLAN_GPIO_PIN15_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN15_CONFIG_LSB) & WLAN_GPIO_PIN15_CONFIG_MASK)
#define WLAN_GPIO_PIN15_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN15_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN15_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN15_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN15_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN15_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN15_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN15_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN15_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN15_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN15_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN15_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN15_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN15_INT_TYPE_MASK) >> WLAN_GPIO_PIN15_INT_TYPE_LSB)
#define WLAN_GPIO_PIN15_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN15_INT_TYPE_LSB) & WLAN_GPIO_PIN15_INT_TYPE_MASK)
#define WLAN_GPIO_PIN15_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN15_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN15_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN15_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN15_PAD_PULL_MASK) >> WLAN_GPIO_PIN15_PAD_PULL_LSB)
#define WLAN_GPIO_PIN15_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN15_PAD_PULL_LSB) & WLAN_GPIO_PIN15_PAD_PULL_MASK)
#define WLAN_GPIO_PIN15_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN15_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN15_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN15_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN15_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN15_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN15_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN15_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN15_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN15_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN15_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN15_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN15_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN15_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN15_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN15_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN15_PAD_DRIVER_LSB) & WLAN_GPIO_PIN15_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN15_SOURCE_MSB               0
#define WLAN_GPIO_PIN15_SOURCE_LSB               0
#define WLAN_GPIO_PIN15_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN15_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN15_SOURCE_MASK) >> WLAN_GPIO_PIN15_SOURCE_LSB)
#define WLAN_GPIO_PIN15_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN15_SOURCE_LSB) & WLAN_GPIO_PIN15_SOURCE_MASK)

#define WLAN_GPIO_PIN16_ADDRESS                  0x00000068
#define WLAN_GPIO_PIN16_OFFSET                   0x00000068
#define WLAN_GPIO_PIN16_CONFIG_MSB               13
#define WLAN_GPIO_PIN16_CONFIG_LSB               11
#define WLAN_GPIO_PIN16_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN16_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN16_CONFIG_MASK) >> WLAN_GPIO_PIN16_CONFIG_LSB)
#define WLAN_GPIO_PIN16_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN16_CONFIG_LSB) & WLAN_GPIO_PIN16_CONFIG_MASK)
#define WLAN_GPIO_PIN16_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN16_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN16_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN16_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN16_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN16_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN16_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN16_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN16_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN16_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN16_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN16_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN16_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN16_INT_TYPE_MASK) >> WLAN_GPIO_PIN16_INT_TYPE_LSB)
#define WLAN_GPIO_PIN16_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN16_INT_TYPE_LSB) & WLAN_GPIO_PIN16_INT_TYPE_MASK)
#define WLAN_GPIO_PIN16_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN16_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN16_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN16_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN16_PAD_PULL_MASK) >> WLAN_GPIO_PIN16_PAD_PULL_LSB)
#define WLAN_GPIO_PIN16_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN16_PAD_PULL_LSB) & WLAN_GPIO_PIN16_PAD_PULL_MASK)
#define WLAN_GPIO_PIN16_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN16_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN16_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN16_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN16_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN16_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN16_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN16_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN16_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN16_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN16_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN16_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN16_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN16_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN16_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN16_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN16_PAD_DRIVER_LSB) & WLAN_GPIO_PIN16_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN16_SOURCE_MSB               0
#define WLAN_GPIO_PIN16_SOURCE_LSB               0
#define WLAN_GPIO_PIN16_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN16_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN16_SOURCE_MASK) >> WLAN_GPIO_PIN16_SOURCE_LSB)
#define WLAN_GPIO_PIN16_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN16_SOURCE_LSB) & WLAN_GPIO_PIN16_SOURCE_MASK)

#define WLAN_GPIO_PIN17_ADDRESS                  0x0000006c
#define WLAN_GPIO_PIN17_OFFSET                   0x0000006c
#define WLAN_GPIO_PIN17_CONFIG_MSB               13
#define WLAN_GPIO_PIN17_CONFIG_LSB               11
#define WLAN_GPIO_PIN17_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN17_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN17_CONFIG_MASK) >> WLAN_GPIO_PIN17_CONFIG_LSB)
#define WLAN_GPIO_PIN17_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN17_CONFIG_LSB) & WLAN_GPIO_PIN17_CONFIG_MASK)
#define WLAN_GPIO_PIN17_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN17_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN17_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN17_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN17_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN17_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN17_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN17_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN17_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN17_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN17_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN17_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN17_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN17_INT_TYPE_MASK) >> WLAN_GPIO_PIN17_INT_TYPE_LSB)
#define WLAN_GPIO_PIN17_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN17_INT_TYPE_LSB) & WLAN_GPIO_PIN17_INT_TYPE_MASK)
#define WLAN_GPIO_PIN17_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN17_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN17_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN17_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN17_PAD_PULL_MASK) >> WLAN_GPIO_PIN17_PAD_PULL_LSB)
#define WLAN_GPIO_PIN17_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN17_PAD_PULL_LSB) & WLAN_GPIO_PIN17_PAD_PULL_MASK)
#define WLAN_GPIO_PIN17_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN17_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN17_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN17_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN17_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN17_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN17_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN17_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN17_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN17_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN17_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN17_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN17_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN17_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN17_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN17_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN17_PAD_DRIVER_LSB) & WLAN_GPIO_PIN17_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN17_SOURCE_MSB               0
#define WLAN_GPIO_PIN17_SOURCE_LSB               0
#define WLAN_GPIO_PIN17_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN17_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN17_SOURCE_MASK) >> WLAN_GPIO_PIN17_SOURCE_LSB)
#define WLAN_GPIO_PIN17_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN17_SOURCE_LSB) & WLAN_GPIO_PIN17_SOURCE_MASK)

#define WLAN_GPIO_PIN18_ADDRESS                  0x00000070
#define WLAN_GPIO_PIN18_OFFSET                   0x00000070
#define WLAN_GPIO_PIN18_CONFIG_MSB               13
#define WLAN_GPIO_PIN18_CONFIG_LSB               11
#define WLAN_GPIO_PIN18_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN18_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN18_CONFIG_MASK) >> WLAN_GPIO_PIN18_CONFIG_LSB)
#define WLAN_GPIO_PIN18_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN18_CONFIG_LSB) & WLAN_GPIO_PIN18_CONFIG_MASK)
#define WLAN_GPIO_PIN18_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN18_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN18_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN18_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN18_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN18_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN18_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN18_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN18_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN18_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN18_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN18_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN18_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN18_INT_TYPE_MASK) >> WLAN_GPIO_PIN18_INT_TYPE_LSB)
#define WLAN_GPIO_PIN18_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN18_INT_TYPE_LSB) & WLAN_GPIO_PIN18_INT_TYPE_MASK)
#define WLAN_GPIO_PIN18_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN18_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN18_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN18_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN18_PAD_PULL_MASK) >> WLAN_GPIO_PIN18_PAD_PULL_LSB)
#define WLAN_GPIO_PIN18_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN18_PAD_PULL_LSB) & WLAN_GPIO_PIN18_PAD_PULL_MASK)
#define WLAN_GPIO_PIN18_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN18_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN18_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN18_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN18_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN18_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN18_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN18_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN18_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN18_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN18_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN18_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN18_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN18_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN18_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN18_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN18_PAD_DRIVER_LSB) & WLAN_GPIO_PIN18_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN18_SOURCE_MSB               0
#define WLAN_GPIO_PIN18_SOURCE_LSB               0
#define WLAN_GPIO_PIN18_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN18_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN18_SOURCE_MASK) >> WLAN_GPIO_PIN18_SOURCE_LSB)
#define WLAN_GPIO_PIN18_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN18_SOURCE_LSB) & WLAN_GPIO_PIN18_SOURCE_MASK)

#define WLAN_GPIO_PIN19_ADDRESS                  0x00000074
#define WLAN_GPIO_PIN19_OFFSET                   0x00000074
#define WLAN_GPIO_PIN19_CONFIG_MSB               13
#define WLAN_GPIO_PIN19_CONFIG_LSB               11
#define WLAN_GPIO_PIN19_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN19_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN19_CONFIG_MASK) >> WLAN_GPIO_PIN19_CONFIG_LSB)
#define WLAN_GPIO_PIN19_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN19_CONFIG_LSB) & WLAN_GPIO_PIN19_CONFIG_MASK)
#define WLAN_GPIO_PIN19_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN19_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN19_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN19_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN19_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN19_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN19_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN19_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN19_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN19_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN19_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN19_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN19_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN19_INT_TYPE_MASK) >> WLAN_GPIO_PIN19_INT_TYPE_LSB)
#define WLAN_GPIO_PIN19_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN19_INT_TYPE_LSB) & WLAN_GPIO_PIN19_INT_TYPE_MASK)
#define WLAN_GPIO_PIN19_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN19_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN19_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN19_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN19_PAD_PULL_MASK) >> WLAN_GPIO_PIN19_PAD_PULL_LSB)
#define WLAN_GPIO_PIN19_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN19_PAD_PULL_LSB) & WLAN_GPIO_PIN19_PAD_PULL_MASK)
#define WLAN_GPIO_PIN19_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN19_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN19_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN19_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN19_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN19_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN19_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN19_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN19_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN19_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN19_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN19_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN19_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN19_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN19_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN19_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN19_PAD_DRIVER_LSB) & WLAN_GPIO_PIN19_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN19_SOURCE_MSB               0
#define WLAN_GPIO_PIN19_SOURCE_LSB               0
#define WLAN_GPIO_PIN19_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN19_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN19_SOURCE_MASK) >> WLAN_GPIO_PIN19_SOURCE_LSB)
#define WLAN_GPIO_PIN19_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN19_SOURCE_LSB) & WLAN_GPIO_PIN19_SOURCE_MASK)

#define WLAN_GPIO_PIN20_ADDRESS                  0x00000078
#define WLAN_GPIO_PIN20_OFFSET                   0x00000078
#define WLAN_GPIO_PIN20_CONFIG_MSB               13
#define WLAN_GPIO_PIN20_CONFIG_LSB               11
#define WLAN_GPIO_PIN20_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN20_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN20_CONFIG_MASK) >> WLAN_GPIO_PIN20_CONFIG_LSB)
#define WLAN_GPIO_PIN20_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN20_CONFIG_LSB) & WLAN_GPIO_PIN20_CONFIG_MASK)
#define WLAN_GPIO_PIN20_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN20_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN20_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN20_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN20_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN20_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN20_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN20_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN20_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN20_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN20_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN20_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN20_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN20_INT_TYPE_MASK) >> WLAN_GPIO_PIN20_INT_TYPE_LSB)
#define WLAN_GPIO_PIN20_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN20_INT_TYPE_LSB) & WLAN_GPIO_PIN20_INT_TYPE_MASK)
#define WLAN_GPIO_PIN20_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN20_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN20_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN20_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN20_PAD_PULL_MASK) >> WLAN_GPIO_PIN20_PAD_PULL_LSB)
#define WLAN_GPIO_PIN20_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN20_PAD_PULL_LSB) & WLAN_GPIO_PIN20_PAD_PULL_MASK)
#define WLAN_GPIO_PIN20_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN20_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN20_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN20_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN20_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN20_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN20_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN20_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN20_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN20_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN20_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN20_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN20_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN20_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN20_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN20_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN20_PAD_DRIVER_LSB) & WLAN_GPIO_PIN20_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN20_SOURCE_MSB               0
#define WLAN_GPIO_PIN20_SOURCE_LSB               0
#define WLAN_GPIO_PIN20_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN20_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN20_SOURCE_MASK) >> WLAN_GPIO_PIN20_SOURCE_LSB)
#define WLAN_GPIO_PIN20_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN20_SOURCE_LSB) & WLAN_GPIO_PIN20_SOURCE_MASK)

#define WLAN_GPIO_PIN21_ADDRESS                  0x0000007c
#define WLAN_GPIO_PIN21_OFFSET                   0x0000007c
#define WLAN_GPIO_PIN21_CONFIG_MSB               13
#define WLAN_GPIO_PIN21_CONFIG_LSB               11
#define WLAN_GPIO_PIN21_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN21_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN21_CONFIG_MASK) >> WLAN_GPIO_PIN21_CONFIG_LSB)
#define WLAN_GPIO_PIN21_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN21_CONFIG_LSB) & WLAN_GPIO_PIN21_CONFIG_MASK)
#define WLAN_GPIO_PIN21_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN21_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN21_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN21_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN21_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN21_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN21_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN21_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN21_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN21_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN21_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN21_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN21_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN21_INT_TYPE_MASK) >> WLAN_GPIO_PIN21_INT_TYPE_LSB)
#define WLAN_GPIO_PIN21_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN21_INT_TYPE_LSB) & WLAN_GPIO_PIN21_INT_TYPE_MASK)
#define WLAN_GPIO_PIN21_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN21_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN21_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN21_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN21_PAD_PULL_MASK) >> WLAN_GPIO_PIN21_PAD_PULL_LSB)
#define WLAN_GPIO_PIN21_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN21_PAD_PULL_LSB) & WLAN_GPIO_PIN21_PAD_PULL_MASK)
#define WLAN_GPIO_PIN21_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN21_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN21_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN21_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN21_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN21_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN21_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN21_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN21_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN21_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN21_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN21_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN21_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN21_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN21_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN21_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN21_PAD_DRIVER_LSB) & WLAN_GPIO_PIN21_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN21_SOURCE_MSB               0
#define WLAN_GPIO_PIN21_SOURCE_LSB               0
#define WLAN_GPIO_PIN21_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN21_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN21_SOURCE_MASK) >> WLAN_GPIO_PIN21_SOURCE_LSB)
#define WLAN_GPIO_PIN21_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN21_SOURCE_LSB) & WLAN_GPIO_PIN21_SOURCE_MASK)

#define WLAN_GPIO_PIN22_ADDRESS                  0x00000080
#define WLAN_GPIO_PIN22_OFFSET                   0x00000080
#define WLAN_GPIO_PIN22_CONFIG_MSB               13
#define WLAN_GPIO_PIN22_CONFIG_LSB               11
#define WLAN_GPIO_PIN22_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN22_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN22_CONFIG_MASK) >> WLAN_GPIO_PIN22_CONFIG_LSB)
#define WLAN_GPIO_PIN22_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN22_CONFIG_LSB) & WLAN_GPIO_PIN22_CONFIG_MASK)
#define WLAN_GPIO_PIN22_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN22_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN22_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN22_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN22_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN22_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN22_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN22_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN22_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN22_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN22_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN22_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN22_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN22_INT_TYPE_MASK) >> WLAN_GPIO_PIN22_INT_TYPE_LSB)
#define WLAN_GPIO_PIN22_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN22_INT_TYPE_LSB) & WLAN_GPIO_PIN22_INT_TYPE_MASK)
#define WLAN_GPIO_PIN22_PAD_PULL_MSB             6
#define WLAN_GPIO_PIN22_PAD_PULL_LSB             5
#define WLAN_GPIO_PIN22_PAD_PULL_MASK            0x00000060
#define WLAN_GPIO_PIN22_PAD_PULL_GET(x)          (((x) & WLAN_GPIO_PIN22_PAD_PULL_MASK) >> WLAN_GPIO_PIN22_PAD_PULL_LSB)
#define WLAN_GPIO_PIN22_PAD_PULL_SET(x)          (((x) << WLAN_GPIO_PIN22_PAD_PULL_LSB) & WLAN_GPIO_PIN22_PAD_PULL_MASK)
#define WLAN_GPIO_PIN22_PAD_STRENGTH_MSB         4
#define WLAN_GPIO_PIN22_PAD_STRENGTH_LSB         3
#define WLAN_GPIO_PIN22_PAD_STRENGTH_MASK        0x00000018
#define WLAN_GPIO_PIN22_PAD_STRENGTH_GET(x)      (((x) & WLAN_GPIO_PIN22_PAD_STRENGTH_MASK) >> WLAN_GPIO_PIN22_PAD_STRENGTH_LSB)
#define WLAN_GPIO_PIN22_PAD_STRENGTH_SET(x)      (((x) << WLAN_GPIO_PIN22_PAD_STRENGTH_LSB) & WLAN_GPIO_PIN22_PAD_STRENGTH_MASK)
#define WLAN_GPIO_PIN22_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN22_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN22_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN22_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN22_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN22_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN22_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN22_PAD_DRIVER_LSB) & WLAN_GPIO_PIN22_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN22_SOURCE_MSB               0
#define WLAN_GPIO_PIN22_SOURCE_LSB               0
#define WLAN_GPIO_PIN22_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN22_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN22_SOURCE_MASK) >> WLAN_GPIO_PIN22_SOURCE_LSB)
#define WLAN_GPIO_PIN22_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN22_SOURCE_LSB) & WLAN_GPIO_PIN22_SOURCE_MASK)

#define WLAN_GPIO_PIN23_ADDRESS                  0x00000084
#define WLAN_GPIO_PIN23_OFFSET                   0x00000084
#define WLAN_GPIO_PIN23_CONFIG_MSB               13
#define WLAN_GPIO_PIN23_CONFIG_LSB               11
#define WLAN_GPIO_PIN23_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN23_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN23_CONFIG_MASK) >> WLAN_GPIO_PIN23_CONFIG_LSB)
#define WLAN_GPIO_PIN23_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN23_CONFIG_LSB) & WLAN_GPIO_PIN23_CONFIG_MASK)
#define WLAN_GPIO_PIN23_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN23_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN23_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN23_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN23_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN23_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN23_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN23_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN23_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN23_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN23_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN23_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN23_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN23_INT_TYPE_MASK) >> WLAN_GPIO_PIN23_INT_TYPE_LSB)
#define WLAN_GPIO_PIN23_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN23_INT_TYPE_LSB) & WLAN_GPIO_PIN23_INT_TYPE_MASK)
#define WLAN_GPIO_PIN23_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN23_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN23_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN23_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN23_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN23_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN23_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN23_PAD_DRIVER_LSB) & WLAN_GPIO_PIN23_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN23_SOURCE_MSB               0
#define WLAN_GPIO_PIN23_SOURCE_LSB               0
#define WLAN_GPIO_PIN23_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN23_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN23_SOURCE_MASK) >> WLAN_GPIO_PIN23_SOURCE_LSB)
#define WLAN_GPIO_PIN23_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN23_SOURCE_LSB) & WLAN_GPIO_PIN23_SOURCE_MASK)

#define WLAN_GPIO_PIN24_ADDRESS                  0x00000088
#define WLAN_GPIO_PIN24_OFFSET                   0x00000088
#define WLAN_GPIO_PIN24_CONFIG_MSB               13
#define WLAN_GPIO_PIN24_CONFIG_LSB               11
#define WLAN_GPIO_PIN24_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN24_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN24_CONFIG_MASK) >> WLAN_GPIO_PIN24_CONFIG_LSB)
#define WLAN_GPIO_PIN24_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN24_CONFIG_LSB) & WLAN_GPIO_PIN24_CONFIG_MASK)
#define WLAN_GPIO_PIN24_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN24_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN24_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN24_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN24_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN24_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN24_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN24_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN24_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN24_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN24_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN24_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN24_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN24_INT_TYPE_MASK) >> WLAN_GPIO_PIN24_INT_TYPE_LSB)
#define WLAN_GPIO_PIN24_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN24_INT_TYPE_LSB) & WLAN_GPIO_PIN24_INT_TYPE_MASK)
#define WLAN_GPIO_PIN24_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN24_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN24_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN24_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN24_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN24_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN24_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN24_PAD_DRIVER_LSB) & WLAN_GPIO_PIN24_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN24_SOURCE_MSB               0
#define WLAN_GPIO_PIN24_SOURCE_LSB               0
#define WLAN_GPIO_PIN24_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN24_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN24_SOURCE_MASK) >> WLAN_GPIO_PIN24_SOURCE_LSB)
#define WLAN_GPIO_PIN24_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN24_SOURCE_LSB) & WLAN_GPIO_PIN24_SOURCE_MASK)

#define WLAN_GPIO_PIN25_ADDRESS                  0x0000008c
#define WLAN_GPIO_PIN25_OFFSET                   0x0000008c
#define WLAN_GPIO_PIN25_CONFIG_MSB               13
#define WLAN_GPIO_PIN25_CONFIG_LSB               11
#define WLAN_GPIO_PIN25_CONFIG_MASK              0x00003800
#define WLAN_GPIO_PIN25_CONFIG_GET(x)            (((x) & WLAN_GPIO_PIN25_CONFIG_MASK) >> WLAN_GPIO_PIN25_CONFIG_LSB)
#define WLAN_GPIO_PIN25_CONFIG_SET(x)            (((x) << WLAN_GPIO_PIN25_CONFIG_LSB) & WLAN_GPIO_PIN25_CONFIG_MASK)
#define WLAN_GPIO_PIN25_WAKEUP_ENABLE_MSB        10
#define WLAN_GPIO_PIN25_WAKEUP_ENABLE_LSB        10
#define WLAN_GPIO_PIN25_WAKEUP_ENABLE_MASK       0x00000400
#define WLAN_GPIO_PIN25_WAKEUP_ENABLE_GET(x)     (((x) & WLAN_GPIO_PIN25_WAKEUP_ENABLE_MASK) >> WLAN_GPIO_PIN25_WAKEUP_ENABLE_LSB)
#define WLAN_GPIO_PIN25_WAKEUP_ENABLE_SET(x)     (((x) << WLAN_GPIO_PIN25_WAKEUP_ENABLE_LSB) & WLAN_GPIO_PIN25_WAKEUP_ENABLE_MASK)
#define WLAN_GPIO_PIN25_INT_TYPE_MSB             9
#define WLAN_GPIO_PIN25_INT_TYPE_LSB             7
#define WLAN_GPIO_PIN25_INT_TYPE_MASK            0x00000380
#define WLAN_GPIO_PIN25_INT_TYPE_GET(x)          (((x) & WLAN_GPIO_PIN25_INT_TYPE_MASK) >> WLAN_GPIO_PIN25_INT_TYPE_LSB)
#define WLAN_GPIO_PIN25_INT_TYPE_SET(x)          (((x) << WLAN_GPIO_PIN25_INT_TYPE_LSB) & WLAN_GPIO_PIN25_INT_TYPE_MASK)
#define WLAN_GPIO_PIN25_PAD_DRIVER_MSB           2
#define WLAN_GPIO_PIN25_PAD_DRIVER_LSB           2
#define WLAN_GPIO_PIN25_PAD_DRIVER_MASK          0x00000004
#define WLAN_GPIO_PIN25_PAD_DRIVER_GET(x)        (((x) & WLAN_GPIO_PIN25_PAD_DRIVER_MASK) >> WLAN_GPIO_PIN25_PAD_DRIVER_LSB)
#define WLAN_GPIO_PIN25_PAD_DRIVER_SET(x)        (((x) << WLAN_GPIO_PIN25_PAD_DRIVER_LSB) & WLAN_GPIO_PIN25_PAD_DRIVER_MASK)
#define WLAN_GPIO_PIN25_SOURCE_MSB               0
#define WLAN_GPIO_PIN25_SOURCE_LSB               0
#define WLAN_GPIO_PIN25_SOURCE_MASK              0x00000001
#define WLAN_GPIO_PIN25_SOURCE_GET(x)            (((x) & WLAN_GPIO_PIN25_SOURCE_MASK) >> WLAN_GPIO_PIN25_SOURCE_LSB)
#define WLAN_GPIO_PIN25_SOURCE_SET(x)            (((x) << WLAN_GPIO_PIN25_SOURCE_LSB) & WLAN_GPIO_PIN25_SOURCE_MASK)

#define SDIO_ADDRESS                             0x00000090
#define SDIO_OFFSET                              0x00000090
#define SDIO_PINS_EN_MSB                         0
#define SDIO_PINS_EN_LSB                         0
#define SDIO_PINS_EN_MASK                        0x00000001
#define SDIO_PINS_EN_GET(x)                      (((x) & SDIO_PINS_EN_MASK) >> SDIO_PINS_EN_LSB)
#define SDIO_PINS_EN_SET(x)                      (((x) << SDIO_PINS_EN_LSB) & SDIO_PINS_EN_MASK)

#define FUNC_BUS_ADDRESS                         0x00000094
#define FUNC_BUS_OFFSET                          0x00000094
#define FUNC_BUS_GPIO_MODE_MSB                   22
#define FUNC_BUS_GPIO_MODE_LSB                   22
#define FUNC_BUS_GPIO_MODE_MASK                  0x00400000
#define FUNC_BUS_GPIO_MODE_GET(x)                (((x) & FUNC_BUS_GPIO_MODE_MASK) >> FUNC_BUS_GPIO_MODE_LSB)
#define FUNC_BUS_GPIO_MODE_SET(x)                (((x) << FUNC_BUS_GPIO_MODE_LSB) & FUNC_BUS_GPIO_MODE_MASK)
#define FUNC_BUS_OE_L_MSB                        21
#define FUNC_BUS_OE_L_LSB                        0
#define FUNC_BUS_OE_L_MASK                       0x003fffff
#define FUNC_BUS_OE_L_GET(x)                     (((x) & FUNC_BUS_OE_L_MASK) >> FUNC_BUS_OE_L_LSB)
#define FUNC_BUS_OE_L_SET(x)                     (((x) << FUNC_BUS_OE_L_LSB) & FUNC_BUS_OE_L_MASK)

#define WL_SOC_APB_ADDRESS                       0x00000098
#define WL_SOC_APB_OFFSET                        0x00000098
#define WL_SOC_APB_TOGGLE_MSB                    0
#define WL_SOC_APB_TOGGLE_LSB                    0
#define WL_SOC_APB_TOGGLE_MASK                   0x00000001
#define WL_SOC_APB_TOGGLE_GET(x)                 (((x) & WL_SOC_APB_TOGGLE_MASK) >> WL_SOC_APB_TOGGLE_LSB)
#define WL_SOC_APB_TOGGLE_SET(x)                 (((x) << WL_SOC_APB_TOGGLE_LSB) & WL_SOC_APB_TOGGLE_MASK)

#define WLAN_SIGMA_DELTA_ADDRESS                 0x0000009c
#define WLAN_SIGMA_DELTA_OFFSET                  0x0000009c
#define WLAN_SIGMA_DELTA_ENABLE_MSB              16
#define WLAN_SIGMA_DELTA_ENABLE_LSB              16
#define WLAN_SIGMA_DELTA_ENABLE_MASK             0x00010000
#define WLAN_SIGMA_DELTA_ENABLE_GET(x)           (((x) & WLAN_SIGMA_DELTA_ENABLE_MASK) >> WLAN_SIGMA_DELTA_ENABLE_LSB)
#define WLAN_SIGMA_DELTA_ENABLE_SET(x)           (((x) << WLAN_SIGMA_DELTA_ENABLE_LSB) & WLAN_SIGMA_DELTA_ENABLE_MASK)
#define WLAN_SIGMA_DELTA_PRESCALAR_MSB           15
#define WLAN_SIGMA_DELTA_PRESCALAR_LSB           8
#define WLAN_SIGMA_DELTA_PRESCALAR_MASK          0x0000ff00
#define WLAN_SIGMA_DELTA_PRESCALAR_GET(x)        (((x) & WLAN_SIGMA_DELTA_PRESCALAR_MASK) >> WLAN_SIGMA_DELTA_PRESCALAR_LSB)
#define WLAN_SIGMA_DELTA_PRESCALAR_SET(x)        (((x) << WLAN_SIGMA_DELTA_PRESCALAR_LSB) & WLAN_SIGMA_DELTA_PRESCALAR_MASK)
#define WLAN_SIGMA_DELTA_TARGET_MSB              7
#define WLAN_SIGMA_DELTA_TARGET_LSB              0
#define WLAN_SIGMA_DELTA_TARGET_MASK             0x000000ff
#define WLAN_SIGMA_DELTA_TARGET_GET(x)           (((x) & WLAN_SIGMA_DELTA_TARGET_MASK) >> WLAN_SIGMA_DELTA_TARGET_LSB)
#define WLAN_SIGMA_DELTA_TARGET_SET(x)           (((x) << WLAN_SIGMA_DELTA_TARGET_LSB) & WLAN_SIGMA_DELTA_TARGET_MASK)

#define WL_BOOTSTRAP_ADDRESS                     0x000000a0
#define WL_BOOTSTRAP_OFFSET                      0x000000a0
#define WL_BOOTSTRAP_STATUS_MSB                  22
#define WL_BOOTSTRAP_STATUS_LSB                  0
#define WL_BOOTSTRAP_STATUS_MASK                 0x007fffff
#define WL_BOOTSTRAP_STATUS_GET(x)               (((x) & WL_BOOTSTRAP_STATUS_MASK) >> WL_BOOTSTRAP_STATUS_LSB)
#define WL_BOOTSTRAP_STATUS_SET(x)               (((x) << WL_BOOTSTRAP_STATUS_LSB) & WL_BOOTSTRAP_STATUS_MASK)

#define CLOCK_GPIO_ADDRESS                       0x000000a4
#define CLOCK_GPIO_OFFSET                        0x000000a4
#define CLOCK_GPIO_CLK_REQ_OUT_EN_MSB            2
#define CLOCK_GPIO_CLK_REQ_OUT_EN_LSB            2
#define CLOCK_GPIO_CLK_REQ_OUT_EN_MASK           0x00000004
#define CLOCK_GPIO_CLK_REQ_OUT_EN_GET(x)         (((x) & CLOCK_GPIO_CLK_REQ_OUT_EN_MASK) >> CLOCK_GPIO_CLK_REQ_OUT_EN_LSB)
#define CLOCK_GPIO_CLK_REQ_OUT_EN_SET(x)         (((x) << CLOCK_GPIO_CLK_REQ_OUT_EN_LSB) & CLOCK_GPIO_CLK_REQ_OUT_EN_MASK)
#define CLOCK_GPIO_BT_CLK_REQ_EN_MSB             1
#define CLOCK_GPIO_BT_CLK_REQ_EN_LSB             1
#define CLOCK_GPIO_BT_CLK_REQ_EN_MASK            0x00000002
#define CLOCK_GPIO_BT_CLK_REQ_EN_GET(x)          (((x) & CLOCK_GPIO_BT_CLK_REQ_EN_MASK) >> CLOCK_GPIO_BT_CLK_REQ_EN_LSB)
#define CLOCK_GPIO_BT_CLK_REQ_EN_SET(x)          (((x) << CLOCK_GPIO_BT_CLK_REQ_EN_LSB) & CLOCK_GPIO_BT_CLK_REQ_EN_MASK)
#define CLOCK_GPIO_BT_CLK_OUT_EN_MSB             0
#define CLOCK_GPIO_BT_CLK_OUT_EN_LSB             0
#define CLOCK_GPIO_BT_CLK_OUT_EN_MASK            0x00000001
#define CLOCK_GPIO_BT_CLK_OUT_EN_GET(x)          (((x) & CLOCK_GPIO_BT_CLK_OUT_EN_MASK) >> CLOCK_GPIO_BT_CLK_OUT_EN_LSB)
#define CLOCK_GPIO_BT_CLK_OUT_EN_SET(x)          (((x) << CLOCK_GPIO_BT_CLK_OUT_EN_LSB) & CLOCK_GPIO_BT_CLK_OUT_EN_MASK)

#define WLAN_DEBUG_CONTROL_ADDRESS               0x000000a8
#define WLAN_DEBUG_CONTROL_OFFSET                0x000000a8
#define WLAN_DEBUG_CONTROL_ENABLE_MSB            0
#define WLAN_DEBUG_CONTROL_ENABLE_LSB            0
#define WLAN_DEBUG_CONTROL_ENABLE_MASK           0x00000001
#define WLAN_DEBUG_CONTROL_ENABLE_GET(x)         (((x) & WLAN_DEBUG_CONTROL_ENABLE_MASK) >> WLAN_DEBUG_CONTROL_ENABLE_LSB)
#define WLAN_DEBUG_CONTROL_ENABLE_SET(x)         (((x) << WLAN_DEBUG_CONTROL_ENABLE_LSB) & WLAN_DEBUG_CONTROL_ENABLE_MASK)

#define WLAN_DEBUG_INPUT_SEL_ADDRESS             0x000000ac
#define WLAN_DEBUG_INPUT_SEL_OFFSET              0x000000ac
#define WLAN_DEBUG_INPUT_SEL_SHIFT_MSB           5
#define WLAN_DEBUG_INPUT_SEL_SHIFT_LSB           4
#define WLAN_DEBUG_INPUT_SEL_SHIFT_MASK          0x00000030
#define WLAN_DEBUG_INPUT_SEL_SHIFT_GET(x)        (((x) & WLAN_DEBUG_INPUT_SEL_SHIFT_MASK) >> WLAN_DEBUG_INPUT_SEL_SHIFT_LSB)
#define WLAN_DEBUG_INPUT_SEL_SHIFT_SET(x)        (((x) << WLAN_DEBUG_INPUT_SEL_SHIFT_LSB) & WLAN_DEBUG_INPUT_SEL_SHIFT_MASK)
#define WLAN_DEBUG_INPUT_SEL_SRC_MSB             3
#define WLAN_DEBUG_INPUT_SEL_SRC_LSB             0
#define WLAN_DEBUG_INPUT_SEL_SRC_MASK            0x0000000f
#define WLAN_DEBUG_INPUT_SEL_SRC_GET(x)          (((x) & WLAN_DEBUG_INPUT_SEL_SRC_MASK) >> WLAN_DEBUG_INPUT_SEL_SRC_LSB)
#define WLAN_DEBUG_INPUT_SEL_SRC_SET(x)          (((x) << WLAN_DEBUG_INPUT_SEL_SRC_LSB) & WLAN_DEBUG_INPUT_SEL_SRC_MASK)

#define WLAN_DEBUG_OUT_ADDRESS                   0x000000b0
#define WLAN_DEBUG_OUT_OFFSET                    0x000000b0
#define WLAN_DEBUG_OUT_DATA_MSB                  17
#define WLAN_DEBUG_OUT_DATA_LSB                  0
#define WLAN_DEBUG_OUT_DATA_MASK                 0x0003ffff
#define WLAN_DEBUG_OUT_DATA_GET(x)               (((x) & WLAN_DEBUG_OUT_DATA_MASK) >> WLAN_DEBUG_OUT_DATA_LSB)
#define WLAN_DEBUG_OUT_DATA_SET(x)               (((x) << WLAN_DEBUG_OUT_DATA_LSB) & WLAN_DEBUG_OUT_DATA_MASK)

#define WLAN_RESET_TUPLE_STATUS_ADDRESS          0x000000b4
#define WLAN_RESET_TUPLE_STATUS_OFFSET           0x000000b4
#define WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_MSB 11
#define WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_LSB 8
#define WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_MASK 0x00000f00
#define WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_GET(x) (((x) & WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_MASK) >> WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_LSB)
#define WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_SET(x) (((x) << WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_LSB) & WLAN_RESET_TUPLE_STATUS_TEST_RESET_TUPLE_MASK)
#define WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_MSB 7
#define WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_LSB 0
#define WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_MASK 0x000000ff
#define WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_GET(x) (((x) & WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_MASK) >> WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_LSB)
#define WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_SET(x) (((x) << WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_LSB) & WLAN_RESET_TUPLE_STATUS_PIN_RESET_TUPLE_MASK)

#define ANTENNA_SLEEP_CONTROL_ADDRESS            0x000000b8
#define ANTENNA_SLEEP_CONTROL_OFFSET             0x000000b8
#define ANTENNA_SLEEP_CONTROL_OVERRIDE_MSB       14
#define ANTENNA_SLEEP_CONTROL_OVERRIDE_LSB       10
#define ANTENNA_SLEEP_CONTROL_OVERRIDE_MASK      0x00007c00
#define ANTENNA_SLEEP_CONTROL_OVERRIDE_GET(x)    (((x) & ANTENNA_SLEEP_CONTROL_OVERRIDE_MASK) >> ANTENNA_SLEEP_CONTROL_OVERRIDE_LSB)
#define ANTENNA_SLEEP_CONTROL_OVERRIDE_SET(x)    (((x) << ANTENNA_SLEEP_CONTROL_OVERRIDE_LSB) & ANTENNA_SLEEP_CONTROL_OVERRIDE_MASK)
#define ANTENNA_SLEEP_CONTROL_VALUE_MSB          9
#define ANTENNA_SLEEP_CONTROL_VALUE_LSB          5
#define ANTENNA_SLEEP_CONTROL_VALUE_MASK         0x000003e0
#define ANTENNA_SLEEP_CONTROL_VALUE_GET(x)       (((x) & ANTENNA_SLEEP_CONTROL_VALUE_MASK) >> ANTENNA_SLEEP_CONTROL_VALUE_LSB)
#define ANTENNA_SLEEP_CONTROL_VALUE_SET(x)       (((x) << ANTENNA_SLEEP_CONTROL_VALUE_LSB) & ANTENNA_SLEEP_CONTROL_VALUE_MASK)
#define ANTENNA_SLEEP_CONTROL_ENABLE_MSB         4
#define ANTENNA_SLEEP_CONTROL_ENABLE_LSB         0
#define ANTENNA_SLEEP_CONTROL_ENABLE_MASK        0x0000001f
#define ANTENNA_SLEEP_CONTROL_ENABLE_GET(x)      (((x) & ANTENNA_SLEEP_CONTROL_ENABLE_MASK) >> ANTENNA_SLEEP_CONTROL_ENABLE_LSB)
#define ANTENNA_SLEEP_CONTROL_ENABLE_SET(x)      (((x) << ANTENNA_SLEEP_CONTROL_ENABLE_LSB) & ANTENNA_SLEEP_CONTROL_ENABLE_MASK)


#ifndef __ASSEMBLER__

typedef struct gpio_athr_wlan_reg_reg_s {
  volatile unsigned int wlan_gpio_out;
  volatile unsigned int wlan_gpio_out_w1ts;
  volatile unsigned int wlan_gpio_out_w1tc;
  volatile unsigned int wlan_gpio_enable;
  volatile unsigned int wlan_gpio_enable_w1ts;
  volatile unsigned int wlan_gpio_enable_w1tc;
  volatile unsigned int wlan_gpio_in;
  volatile unsigned int wlan_gpio_status;
  volatile unsigned int wlan_gpio_status_w1ts;
  volatile unsigned int wlan_gpio_status_w1tc;
  volatile unsigned int wlan_gpio_pin0;
  volatile unsigned int wlan_gpio_pin1;
  volatile unsigned int wlan_gpio_pin2;
  volatile unsigned int wlan_gpio_pin3;
  volatile unsigned int wlan_gpio_pin4;
  volatile unsigned int wlan_gpio_pin5;
  volatile unsigned int wlan_gpio_pin6;
  volatile unsigned int wlan_gpio_pin7;
  volatile unsigned int wlan_gpio_pin8;
  volatile unsigned int wlan_gpio_pin9;
  volatile unsigned int wlan_gpio_pin10;
  volatile unsigned int wlan_gpio_pin11;
  volatile unsigned int wlan_gpio_pin12;
  volatile unsigned int wlan_gpio_pin13;
  volatile unsigned int wlan_gpio_pin14;
  volatile unsigned int wlan_gpio_pin15;
  volatile unsigned int wlan_gpio_pin16;
  volatile unsigned int wlan_gpio_pin17;
  volatile unsigned int wlan_gpio_pin18;
  volatile unsigned int wlan_gpio_pin19;
  volatile unsigned int wlan_gpio_pin20;
  volatile unsigned int wlan_gpio_pin21;
  volatile unsigned int wlan_gpio_pin22;
  volatile unsigned int wlan_gpio_pin23;
  volatile unsigned int wlan_gpio_pin24;
  volatile unsigned int wlan_gpio_pin25;
  volatile unsigned int sdio;
  volatile unsigned int func_bus;
  volatile unsigned int wl_soc_apb;
  volatile unsigned int wlan_sigma_delta;
  volatile unsigned int wl_bootstrap;
  volatile unsigned int clock_gpio;
  volatile unsigned int wlan_debug_control;
  volatile unsigned int wlan_debug_input_sel;
  volatile unsigned int wlan_debug_out;
  volatile unsigned int wlan_reset_tuple_status;
  volatile unsigned int antenna_sleep_control;
} gpio_athr_wlan_reg_reg_t;

#endif /* __ASSEMBLER__ */

#endif /* _GPIO_ATHR_WLAN_REG_H_ */
